diff -urN src/gtk2/gui/guiInfoWindow.ml src/gtk2/gui/guiInfoWindow.ml
--- src/gtk2/gui/guiInfoWindow.ml	2005-04-26 13:02:21.000000000 +0200
+++ src/gtk2/gui/guiInfoWindow.ml	2005-10-31 12:21:29.000000000 +0100
@@ -105,7 +105,7 @@
 
 let item_name_to_string item =
   match item with
-      File f -> f.file_name
+      File f -> f.g_file_name
     | Source (s, files) -> s.source_name
 
 (*************************************************************************)
@@ -116,7 +116,7 @@
 
 let pixbuf_of_item item =
   match item with
-      File f -> Mi.file_type_of_name f.file_name ~size:A.LARGE
+      File f -> Mi.file_type_of_name f.g_file_name ~size:A.LARGE
     | Source (s, files) -> Mi.source_type_to_icon s.source_type ~size:A.LARGE
 
 (*************************************************************************)
@@ -140,16 +140,16 @@
 let item_info_of_item (table : GPack.table) item =
   match item with
       File f ->
-        let avail = Mi.main_availability_of f.file_network f.file_availability in
+        let avail = Mi.main_availability_of f.g_file_network f.g_file_availability in
         [
-         [!M.fW_lb_file_format; format_to_string table f.file_format];
-         [!M.fW_lb_file_hash;   Mi.uid_list_to_string f.file_uids];
-         [!M.fW_lb_file_size;   Mi.size_of_int64 f.file_size;
-          !M.fW_lb_file_state;  Mi.string_of_file_state f.file_state f.file_download_rate];
-         [!M.fW_lb_file_chunks; Mi.chunks_to_string f.file_chunks;
-          !M.fW_lb_file_avail;  Mi.string_of_availability avail f.file_chunks];
-         [!M.fW_lb_file_age;    Mi.time_to_string f.file_age;
-          !M.fW_lb_file_prio;   Mi.priority_to_string f.file_priority]
+         [!M.fW_lb_file_format; format_to_string table f.g_file_format];
+         [!M.fW_lb_file_hash;   Mi.uid_list_to_string f.g_file_uids];
+         [!M.fW_lb_file_size;   Mi.size_of_int64 f.g_file_size;
+          !M.fW_lb_file_state;  Mi.string_of_file_state f.g_file_state f.g_file_download_rate];
+         [!M.fW_lb_file_chunks; Mi.chunks_to_string f.g_file_chunks;
+          !M.fW_lb_file_avail;  Mi.string_of_availability avail f.g_file_chunks];
+         [!M.fW_lb_file_age;    Mi.time_to_string f.g_file_age;
+          !M.fW_lb_file_prio;   Mi.priority_to_string f.g_file_priority]
         ]
 
     | Source (s, files) ->
@@ -170,13 +170,13 @@
   match item with
       File f ->
         [
-         [!M.fW_lb_file_sources;         Mi.sources_to_string f.file_sources;
-          !M.fW_lb_file_rate;            Mi.average_rate f.file_downloaded f.file_age];
-         [!M.fW_lb_file_dled;            Mi.size_of_int64 f.file_downloaded;
-          !M.fW_lb_file_complete_chunks; Mi.completed_chunks_to_string f.file_chunks];
-         [!M.fW_lb_last_seen;            Mi.time_to_string f.file_last_seen;
-          !M.fW_lb_file_eta;            (Mi.calc_eta_inst f.file_size f.file_downloaded f.file_download_rate) ^ " / " ^
-                                        (Mi.calc_eta_average f.file_size f.file_downloaded f.file_age)]
+         [!M.fW_lb_file_sources;         Mi.sources_to_string f.g_file_sources;
+          !M.fW_lb_file_rate;            Mi.average_rate f.g_file_downloaded f.g_file_age];
+         [!M.fW_lb_file_dled;            Mi.size_of_int64 f.g_file_downloaded;
+          !M.fW_lb_file_complete_chunks; Mi.completed_chunks_to_string f.g_file_chunks];
+         [!M.fW_lb_last_seen;            Mi.time_to_string f.g_file_last_seen;
+          !M.fW_lb_file_eta;            (Mi.calc_eta_inst f.g_file_size f.g_file_downloaded f.g_file_download_rate) ^ " / " ^
+                                        (Mi.calc_eta_average f.g_file_size f.g_file_downloaded f.g_file_age)]
         ]
 
     | Source (s, files) ->
@@ -278,7 +278,7 @@
   let height = 16 in
   List.iter (fun (net_num, avail) ->
     let net_pixb = Mi.network_pixb net_num ~size:A.SMALL () in
-    let avail_bar = Mi.availability_bar avail f.file_chunks true in
+    let avail_bar = Mi.availability_bar avail f.g_file_chunks true in
     let _ =
       match (net_pixb, avail_bar) with
           (Some pb, Some pixb) ->
@@ -306,7 +306,7 @@
       | _ -> ()
     in
     incr top
-  ) f.file_availability;
+  ) f.g_file_availability;
   (!top + 1)
 
 (*************************************************************************)
@@ -322,7 +322,7 @@
 
 let add_file_names (table : GPack.table) f top =
   let height = !wheight * 1 / 4 in
-  let file_name = U.utf8_of f.file_name in
+  let file_name = U.utf8_of f.g_file_name in
   let cols = new GTree.column_list in
   let file_names = cols#add Gobject.Data.string in
   let file_count = cols#add Gobject.Data.int in
@@ -338,7 +338,7 @@
     liststore#set ~row ~column:file_names_pixb pixb;
     liststore#set ~row ~column:file_names s;
     liststore#set ~row ~column:file_count ips.nips;
-  ) f.file_names;
+  ) f.g_file_names;
   let col_name =
     let col =  GTree.view_column ~title:!M.fW_lb_file_names_col () in
     col#set_resizable true;
@@ -389,9 +389,9 @@
   ignore (button#connect#clicked ~callback:
     (fun _ ->
       if entry#text <> "" then
-        match f.file_state with
- 	    FileDownloaded  -> GuiCom.send (GuiProto.SaveFile (f.file_num, entry#text))
-          | _  ->  GuiCom.send (GuiProto.RenameFile (f.file_num, entry#text))
+        match f.g_file_state with
+ 	    FileDownloaded  -> GuiCom.send (GuiProto.SaveFile (f.g_file_num, entry#text))
+          | _  ->  GuiCom.send (GuiProto.RenameFile (f.g_file_num, entry#text))
   ));
   ignore (view#selection#connect#after#changed ~callback:
     (fun _ ->
@@ -427,10 +427,10 @@
       [] -> insert_data table [] top
     | files ->
         begin
-          let file_list = !G.get_files files in
+          let file_list = G.get_files files in
           let l = ref [] in
           List.iter (fun f ->
-            l := [GuiTools.fit_string_to_pixels (U.utf8_of f.file_name) ~context ~pixels] :: !l
+            l := [GuiTools.fit_string_to_pixels (U.utf8_of f.g_file_name) ~context ~pixels] :: !l
           ) file_list;
           insert_data table !l top
         end
diff -urN src/gtk2/gui/guiMain.ml src/gtk2/gui/guiMain.ml
--- src/gtk2/gui/guiMain.ml	2005-08-05 02:56:13.000000000 +0200
+++ src/gtk2/gui/guiMain.ml	2005-10-31 12:45:25.000000000 +0100
@@ -20,6 +20,7 @@
 open Options
 open GuiTypes2
 open CommonTypes
+open GraphTypes
 
 open GMain
 open GtkBase
@@ -47,7 +48,7 @@
 
 let chmod_config () =
   let base_config = 
-    (Filename.concat CommonOptions.home_dir "mlgui.ini")
+    (Filename.concat M.gui_config_dir "mlgui.ini")
   in
   let save_config =
     base_config ^ ".old"
@@ -80,13 +81,12 @@
 
 let value_reader gui t =
   try
-    
+
      begin
         if !!verbose then lprintf' "MESSAGE RECEIVED: %s\n" 
           (string_of_to_gui t);
       end;
-    
-    
+
     match t with
 
       (* The first message received from the core *)
@@ -134,6 +134,8 @@
         begin
           GuiStatusBar.update_updown s.tcp_upload_rate s.tcp_download_rate;
           GuiStatusBar.update_sharedfiles s.nshared_files s.upload_counter;
+          GuiGraphBase.save_record s.tcp_download_rate GraphDownloads;
+          GuiGraphBase.save_record s.tcp_upload_rate GraphUploads;
           if !G.is_docked
             then begin
               let up = float_of_int s.tcp_upload_rate /. 1024. in
@@ -167,8 +169,8 @@
                 else s.source_files_requested
             in
             let s_new = {s with source_files_requested = files_requested} in
-            GuiDownloads.h_add_source s_new file_num;
-            Hashtbl.replace G.sources source_num s_new
+            GuiDownloads.h_add_source s_new file_num;(* seen *)
+            s.source_files_requested <- s_new.source_files_requested;(* seen *)
           with _ -> 
             GuiCom.send (GuiProto.GetClient_info source_num)
         end
@@ -179,8 +181,8 @@
             let s = Hashtbl.find G.sources source_num in
             let files_requested = List.filter (fun num -> num <> file_num) s.source_files_requested in
             let s_new = {s with source_files_requested = files_requested} in
-            GuiDownloads.h_remove_source s_new file_num;
-            Hashtbl.replace G.sources source_num s_new
+            GuiDownloads.h_remove_source s_new file_num;(* seen *)
+            s.source_files_requested <- s_new.source_files_requested;(* seen *)
           with _ -> 
             GuiCom.send (GuiProto.GetClient_info source_num)
         end
@@ -200,8 +202,8 @@
                 {s with source_availability = (file_num, avail) :: avails}
               with _ -> {s with source_availability = (file_num, avail) :: s.source_availability}
             in
-            GuiDownloads.h_update_source_availability s_new file_num;
-            Hashtbl.replace G.sources source_num s_new
+            GuiDownloads.h_update_source_availability s s_new file_num;(* seen *)
+            s.source_availability <- s_new.source_availability(* seen *)
           with _ -> 
             GuiCom.send (GuiProto.GetClient_info source_num)
         end
@@ -214,10 +216,8 @@
                gui.init.downloads <- false
              end
           );
-          GuiDownloads.file_info
-            {f with file_age = (BasicSocket.last_time () - f.file_age);
-                    file_last_seen = (BasicSocket.last_time () - f.file_last_seen);
-            }
+          let file = Mi.file_info_to_g_file_info f in
+          GuiDownloads.file_info file
         end
 
     | Server_info s ->
@@ -269,10 +269,10 @@
           GuiServers.h_server_update_users user.user_server user.user_num;
           GuiRooms.update_user_info user
         end
-    
+
     | Room_add_user (num, user_num) ->
         GuiRooms.add_room_user num user_num
-    
+
     | Room_remove_user (num, user_num) ->
         GuiRooms.remove_room_user num user_num
 
@@ -317,10 +317,10 @@
           try
             let s = Hashtbl.find G.sources source_num in
             let s_new = {s with source_state = state} in
-            GuiDownloads.h_update_source s_new ;
-            GuiUploads.h_update_uploader s_new;
-            GuiFriends.h_update_friend s_new;
-            Hashtbl.replace G.sources s.source_num s_new
+            GuiDownloads.h_update_source s s_new;(* seen *)
+            GuiUploads.h_update_uploader s s_new;(* seen *)
+            GuiFriends.h_update_friend s s_new;(* seen *)
+            s.source_state <- state(* seen *)
           with _ ->
             begin
               GuiCom.send (GuiProto.GetClient_info source_num)
@@ -332,10 +332,10 @@
           try
             let s = Hashtbl.find G.sources source_num in
             let s_new = {s with source_type = friend_kind} in
-            GuiDownloads.h_update_source s_new ;
-            GuiUploads.h_update_uploader s_new;
-            GuiFriends.h_update_friend s_new;
-            Hashtbl.replace G.sources s.source_num s_new
+            GuiDownloads.h_update_source s s_new;(* seen *)
+            GuiUploads.h_update_uploader s s_new;(* seen *)
+            GuiFriends.h_update_friend s s_new;(* seen *)
+            s.source_type <- friend_kind;(* seen *)
           with _ ->
             begin
               GuiCom.send (GuiProto.GetClient_info source_num)
@@ -346,7 +346,7 @@
         GuiResults.result_info r
 
     | Client_file (source_num , dirname, file_num) ->
-        GuiFriends.add_friend_files (source_num , dirname, file_num)
+        GuiFriends.add_friend_files (source_num , dirname, file_num)(* seen *)
 
     | Client_info client ->
         begin
@@ -357,9 +357,9 @@
              end
           );
           let source = Mi.client_to_source client in
-          let s_new =
-            try
-              let s = Hashtbl.find G.sources source.source_num in
+          try
+            let s = Hashtbl.find G.sources source.source_num in
+            let s_new =
               { source with
                 source_files = s.source_files;
                 source_has_upload = s.source_has_upload;
@@ -368,12 +368,16 @@
                 source_upload_rate = Mi.source_upload_rate source s;
                 source_download_rate = Mi.source_download_rate source s;
               }
-            with _ -> source
-          in
-          GuiDownloads.h_update_source s_new;
-          GuiUploads.h_update_uploader s_new;
-          GuiFriends.h_update_friend s_new;
-          Hashtbl.replace G.sources s_new.source_num s_new
+            in
+            GuiDownloads.h_update_source s s_new;(* seen *)
+            GuiUploads.h_update_uploader s s_new;(* seen *)
+            GuiFriends.h_update_friend s s_new;(* seen *)
+            G.hashtbl_update_sources s s_new;(* seen *)
+          with _ ->
+            begin
+              GuiFriends.h_update_friend source source;(* seen *)
+              Hashtbl.add G.sources source.source_num source(* seen *)
+            end
         end
 
     | Room_message (_, PrivateMessage(num, mes) )
@@ -398,17 +402,6 @@
 
     | (DownloadedFiles _|DownloadFiles _|ConnectedServers _) -> assert false
 
-    | Shared_file_info s ->
-        begin
-          (if gui.init.uploads
-             then begin
-               gui.set_splash_screen M.icon_menu_uploads (Mi.remove_ !M.mW_lb_uploads);
-               gui.init.uploads <- false
-             end
-          );
-          GuiUploads. h_shared_file_info s
-        end
-
     | CleanTables (clients, servers) ->
         begin
           let all_sources = Hashtbl2.to_list G.sources in
@@ -431,6 +424,17 @@
           GuiServers.clean_servers_table servers;
         end
 
+    | Shared_file_info s ->
+        begin
+          (if gui.init.uploads
+             then begin
+               gui.set_splash_screen M.icon_menu_uploads (Mi.remove_ !M.mW_lb_uploads);
+               gui.init.uploads <- false
+             end
+          );
+          GuiUploads.h_shared_file_info (Mi.shared_info_to_shared_file s)
+        end
+
     | Shared_file_upload (num, size, requests) ->
         GuiUploads.h_shared_file_upload num size requests
 
@@ -781,7 +785,7 @@
            true
       );
       GMain.main ();
-      
+
   );
   window#show ()
 
@@ -803,7 +807,7 @@
   G.get_metrics_from_gtk_font_list ();
 
   let quit () = 
-    chmod_config (); 
+    chmod_config ();
     (if !G.is_docked then G.tray.destroy_tray ());
     CommonGlobals.exit_properly 0
   in
@@ -813,38 +817,37 @@
 
   ignore (w#event#connect#delete ~callback:
     (fun _ ->
-       w#misc#hide ();
-       let icon = A.get_icon ~icon:M.icon_type_source_normal ~size:A.MEDIUM () in
-       G.tray.create_tray icon "MLDonkey";
-       true
+       if Autoconf.system = "windows"
+         then begin
+           w#misc#hide ();
+           let icon = A.get_icon ~icon:M.icon_type_source_normal ~size:A.MEDIUM () in
+           G.tray.create_tray icon "MLDonkey";
+         end else begin
+           quit ()
+         end;
+         true
   ));
 
   let main_menu = core_menu gui quit in
   GuiStatusBar.menuitem#set_submenu (main_menu);
 
   G.console_message := (fun s -> GuiConsole.insert s);
-  G.get_files := (fun list ->
-    let l = ref [] in
-    List.iter (fun file_num ->
-      try
-        let (_, i) = GuiDownloads.downloadstore#find_item (File_num file_num) in
-        match i with
-            File f -> l := f :: !l
-          | _ -> ()
-      with _ -> ()
-    ) list;
-    !l
-  );
-
+  if Autoconf.system <> "windows"
+    then begin
+      let icon = A.get_icon ~icon:M.icon_type_source_normal ~size:A.MEDIUM () in
+      G.tray.create_tray icon "MLDonkey";
+    end;
+  let win_hidden = ref false in
   !G.set_systray_callback (fun ev ->
     match ev with
         DOUBLE_CLICKED ->
-           begin
+          if Autoconf.system = "windows"
+            then begin
              (if !!verbose then lprintf' "tray double clicked\n");
              G.tray.destroy_tray ();
              w#misc#show ();
              w#maximize ();
-           end
+            end
       | RBUTTON_CLICKED ->
            begin
              (if !!verbose then lprintf' "tray right clicked\n");
@@ -858,7 +861,19 @@
                      win#show ()
                    end
            end
-      | _ -> ()
+      | LBUTTON_CLICKED ->
+          if Autoconf.system <> "windows"
+            then begin
+             (if !!verbose then lprintf' "tray left clicked\n");
+             if !win_hidden
+               then begin
+                 w#misc#show ();
+                 win_hidden := false
+               end else begin
+                 w#misc#hide ();
+                 win_hidden := true
+               end
+           end
   );
 
   CommonGlobals.do_at_exit (fun _ ->
diff -urN src/gtk2/gui/guiMessages.ml src/gtk2/gui/guiMessages.ml
--- src/gtk2/gui/guiMessages.ml	2005-08-05 02:56:13.000000000 +0200
+++ src/gtk2/gui/guiMessages.ml	2005-10-31 10:07:58.000000000 +0100
@@ -23,7 +23,79 @@
 open Options
 open Gettext
 
-let filename = Filename.concat CommonOptions.home_dir "mlnet_strings"
+let bin_dir = Filename.dirname Sys.argv.(0)
+
+let hidden_dir_prefix =
+  if Autoconf.system = "windows" then "" else "."
+
+let config_dir_basename = hidden_dir_prefix ^ "mldonkey"
+
+let home_dir =
+  match Autoconf.system with
+  | "windows" -> if (Filename.basename bin_dir) = "bin" then Filename.dirname bin_dir else "."
+  | _ -> Filename.concat (try Sys.getenv "HOME" with _ -> ".") config_dir_basename
+
+let file_basedir_pre =
+  try
+    let s = Sys.getenv "MLDONKEY_DIR" in
+    if s = "" then home_dir else Filename2.normalize s
+  with _ -> home_dir
+
+let file_basedir =
+(* Creating dirs does work differently on Windows than Unix.
+   Dirs like c:\b are split down by unix2.safe_mkdir to "c".
+   This function splits the directory name into the drive name
+   and chdir to it before creating directories.
+   Non-absolute paths in $MLDONKEY_DIR do not work as well *)
+  if Sys.file_exists (Filename.concat (Sys.getcwd ()) "mlgui.ini") then
+    "."
+  else
+    if Autoconf.system = "windows" && file_basedir_pre <> home_dir then
+      match String2.split file_basedir_pre ':' with
+      | drive :: directory :: _ ->
+          Unix.chdir (drive ^ ":\\");
+          directory
+      | _ -> lprintf "Please provide an absolute path in MLDONKEY_DIR like d:\\mldonkey, exiting...\n"; exit 2
+    else file_basedir_pre
+
+let _ =
+  if not !CommonGlobals.core_included
+    then begin
+      (try
+         Unix2.safe_mkdir file_basedir
+       with e ->
+         lprintf_nl "Exception (%s) trying to create dir %s"
+           (Printexc2.to_string e) file_basedir;
+         exit 2);
+      Unix2.can_write_to_directory file_basedir;
+      Unix.chdir file_basedir;
+      lprintf_nl "Starting MLGui %s ... " Autoconf.current_version;
+      lprintf_nl "MLGui is working in %s" (Sys.getcwd ())
+    end
+
+
+let dirname_concat dir =
+  match Autoconf.system with
+      "windows" -> Filename.concat file_basedir dir
+    | _ -> file_basedir
+
+let lang_dir = dirname_concat "lang"
+let gui_config_dir = dirname_concat "interface"
+let log_dir = dirname_concat "logs"
+
+let _ =
+  if not !CommonGlobals.core_included
+  then begin
+    let filename =
+      try
+        Sys.getenv "MLGUI_STRINGS"
+      with _ ->
+        Filename.concat lang_dir "mlgui_strings"
+    in
+    Unix2.safe_mkdir (Filename.dirname filename);
+    Unix2.can_write_to_directory (Filename.dirname filename);
+    set_strings_file filename
+  end
 
 let _s x = (* lprintf "searching string %s\n" x; *) GuiUtf8.simple_utf8_of (_s "GuiMessages" x)
 
@@ -270,6 +342,18 @@
 
 (* Graph *)
 
+let gT_lb_time_range = ref ""
+let gT_lb_quarter = ref ""
+let gT_lb_hour = ref ""
+let gT_lb_halfday = ref ""
+let gT_lb_day = ref ""
+let gT_lb_week = ref ""
+let gT_lb_month = ref ""
+let gT_lb_year = ref ""
+let gT_lb_global_downloads = ref ""
+let gT_lb_global_uploads = ref ""
+let gT_lb_file_down_up = ref ""
+
 (* file Window *)
 
 let fW_wt_show_file_details  = ref ""
@@ -715,6 +799,18 @@
 
 (* Graph *)
 
+  gT_lb_time_range := _s_ "Time range";
+  gT_lb_quarter := _s "Quarter";
+  gT_lb_hour := _s "Hour";
+  gT_lb_halfday := _s "Half day";
+  gT_lb_day := _s "Day";
+  gT_lb_week := _s "Week";
+  gT_lb_month := _s "Month";
+  gT_lb_year := _s "Year";
+  gT_lb_global_downloads := _s "Global Downloads";
+  gT_lb_global_uploads := _s "Global Uploads";
+  gT_lb_file_down_up := _s "Files Uploads and Downloads";
+
 (* file Window *)
 
   fW_wt_show_file_details  :=  _s "File details";
@@ -969,8 +1065,9 @@
 
 (* Messages and string constants. *)
 
-let chat_config_file = 
-  Filename.concat CommonOptions.home_dir "chat.ini"
+let _ = Unix2.safe_mkdir gui_config_dir
+
+let chat_config_file = Filename.concat gui_config_dir "chat.ini"
 
 (* {2 Command line messages} *)
 
diff -urN src/gtk2/gui/guiMisc.ml src/gtk2/gui/guiMisc.ml
--- src/gtk2/gui/guiMisc.ml	2005-10-16 22:42:53.000000000 +0200
+++ src/gtk2/gui/guiMisc.ml	2005-10-31 12:04:58.000000000 +0100
@@ -60,12 +60,11 @@
 (*                      To pretty-print a file size                               *)
 (*                                                                                *)
 (**********************************************************************************)
-let ko = 1024l
-let mo = Int32.mul ko ko
+let ko = Int32.of_int 1024
   
 let unit_of_string s =
   match String.lowercase s with
-    "mo" -> mo
+    "mo" -> Int32.mul ko ko
   | "ko" -> ko
   | _ -> Int32.one
 
@@ -503,7 +502,7 @@
 (*************************************************************************)
 
 let uploader_state_to_string state has_upload =
-  if has_upload
+  if has_upload = source_has_upload
     then begin
       match state with
           Connected_downloading _  -> !M.dT_tx_updown
@@ -1269,27 +1268,27 @@
 let client_to_source c =
   let s =
     {
-     source_num = c.client_num;
-     source_network = c.client_network;
+     source_num             = c.client_num;
+     source_network         = c.client_network;
 
-     source_kind = c.client_kind;
-     source_state = c.client_state;
-     source_type = c.client_type;
-     source_tags = c.client_tags;
-     source_name = U.utf8_of c.client_name;
-     source_files = None;
-     source_rating = c.client_rating;
-     source_chat_port = c.client_chat_port;
-     source_connect_time = BasicSocket.last_time () - c.client_connect_time;
-     source_last_seen = BasicSocket.current_time ();
-     source_software = concat_strings c.client_software (concat_strings c.client_emulemod c.client_release);
-     source_downloaded = c.client_downloaded;
-     source_uploaded = c.client_uploaded;
-     source_upload_rate = 0.;
-     source_download_rate = 0.;
-     source_upload = c.client_upload;
-     source_has_upload = false;
-     source_availability = [];
+     source_kind            = c.client_kind;
+     source_state           = c.client_state;
+     source_type            = c.client_type;
+     source_tags            = c.client_tags;
+     source_name            = U.utf8_of c.client_name;
+     source_files           = None;
+     source_rating          = c.client_rating;
+     source_chat_port       = c.client_chat_port;
+     source_connect_time    = BasicSocket.last_time () - c.client_connect_time;
+     source_last_seen       = BasicSocket.current_time ();
+     source_software        = concat_strings c.client_software (concat_strings c.client_emulemod c.client_release);
+     source_downloaded      = c.client_downloaded;
+     source_uploaded        = c.client_uploaded;
+     source_upload_rate     = 0.;
+     source_download_rate   = 0.;
+     source_upload          = c.client_upload;
+     source_has_upload      = source_only;
+     source_availability    = [];
      source_files_requested = [];
     }
   in
@@ -1305,3 +1304,65 @@
   match l with
       [] -> ""
     | uid :: _ -> U.simple_utf8_of (Uid.to_string uid)
+
+(*************************************************************************)
+(*                                                                       *)
+(*                        to_uid_type                                    *)
+(*                                                                       *)
+(*************************************************************************)
+
+let to_uid_type l =
+  match l with
+      [] -> NoUid
+    | uid :: _ -> Uid.to_uid uid
+
+(*************************************************************************)
+(*                                                                       *)
+(*                        shared_info_to_shared_file                     *)
+(*                                                                       *)
+(*************************************************************************)
+
+let shared_info_to_shared_file si =
+  {
+    g_shared_num       = si.shared_num;
+    g_shared_network   = si.shared_network;
+    g_shared_filename  = si.shared_filename;
+    g_shared_size      = si.shared_size;
+    g_shared_uploaded  = si.shared_uploaded;
+    g_shared_requests  = si.shared_requests;
+    g_shared_uids      = si.shared_uids;
+    g_shared_last_seen = BasicSocket.current_time ();
+  }
+
+(*************************************************************************)
+(*                                                                       *)
+(*                        file_info_to_g_file_info                       *)
+(*                                                                       *)
+(*************************************************************************)
+
+let file_info_to_g_file_info f =
+  {
+    g_file_num             = f.file_num;
+    g_file_network         = f.file_network;
+
+    g_file_comment         = f.file_comment;
+    g_file_name            = f.file_name;
+    g_file_names           = f.file_names;
+    g_file_size            = f.file_size;
+    g_file_downloaded      = f.file_downloaded;
+    g_file_active_sources  = f.file_active_sources;
+    g_file_all_sources     = f.file_all_sources;
+    g_file_state           = f.file_state;
+    g_file_chunks          = f.file_chunks;
+    g_file_availability    = f.file_availability;
+    g_file_sources         = f.file_sources;
+    g_file_download_rate   = f.file_download_rate;
+    g_file_format          = f.file_format;
+    g_file_chunks_age      = f.file_chunks_age;
+    g_file_age             = (BasicSocket.last_time () - f.file_age);
+    g_file_last_seen       = (BasicSocket.last_time () - f.file_last_seen);
+    g_file_priority        = f.file_priority;
+    g_file_uids            = f.file_uids;
+
+    g_file_razorback_stats = None;
+  }
